      subroutine berdav( period, rho1, pha1, rho2, pha2, rho, pha )
c-----------------------------------------------------------------------

c      implicit none

c-----------------------------------------------------------------------

      real PI, MU, PIMU

      parameter  (  PI     = 3.141592 )
      parameter  (  MU     = 4.*PI*1.E-7 )
      parameter  (  PIMU   = PI * MU )

c-----------------------------------------------------------------------

      real period, rho1, pha1, rho2, pha2, rho, pha, zm, ang
      complex z1, z2, z

c-----------------------------------------------------------------------

      zm = sqrt( 2. * PIMU * abs(rho1) / period )
      z1 = cmplx( (zm*cosd(pha1)), (zm*sind(pha1)) )

      zm = sqrt( 2. * PIMU * abs(rho2) / period )
      z2 = cmplx( (zm*cosd(pha2)), (zm*sind(pha2)) )

      z = ( z1 - z2 )/2.
      rho = period * real( z * conjg(z) ) / ( 2. * PIMU )
      pha = atan2d( aimag(z), real(z) )

      if( (rho1.lt.0.)  .or. (rho2.lt.0.) ) rho = -rho

      return
      end
