      function fzerr( period, rho, pha, rmax, rmin, pmax, pmin )
      real period, rho, pha, rmax, rmin, pmax, pmin
      complex z, zmax, zmin, zerr

c     function to derive the fractional error in Z given the bounds on
c     apparent resistivity and phase 

      if(     period.eq.0. 
     &   .or. rho.lt.0.
     &   .or. pha.eq.-999.     
     &   .or. rmax.lt.0.
     &   .or. rmin.lt.0.
     &   .or. pmax.eq.-999.
     &   .or. pmin.eq.-999. ) then
        fzerr = -999.
      else
        call zconv( 2,    z,  rho,  pha, period )
        call zconv( 2, zmax, rmax, pmax, period )
        call zconv( 2, zmin, rmin, pmin, period )
        zerr = (zmax - zmin)/2.
        fzerr = cabs(zerr)/cabs(z)
      end if

      return
      end
