      subroutine tfread( fin, stat, type, nper, period, tfr, tfi,
     &           tferr, wtf, * )
 
C-----------------------------------------------------------------------
 
      integer look
      real period(*), tfr(*), tfi(*), tferr(*), wtf(*)
      character fin*(*), stat*6, type*3, statx*6, typex*3, flag*1,
     &          form*5, null*1, bell*1
 
      include 'CTRLBLK.inc'
      include 'IO.inc'
 
      data form/ '(9a4)' /
c      data null, bell / 0, 7 /
 
      null = char(0)
      bell = char(7)
 
c-----------------------------------------------------------------------
C
C  SUBROUTINE TO READ IN TF RESPONSE FUNCTIONS IN STANDARD FORMAT
C

      look = 0

      if( iprint.ge.2 ) then
        write(*,*)'TFREAD entered:'
        write(*,*)'          fin = ', fin 
        write(*,*)'         stat = ', stat 
        write(*,*)'         type = ', type 
      end if

      call shiftup(stat)
      call shiftup(type)
 
      if( fin .eq. '*' ) then
        rewind ind1
        look = 1
        goto 2
      end if
 
    1 call tin( 'Give TF datafile ("STOP"=stop; "0"=no file) >', fin )
      if( fin .eq. '0' ) then
        nper = 0
        return
      else if( fin .eq. 'STOP' ) then
        nper = -1
        return 1
      end if
C
      open( unit = ind1, status = 'old', file = fin,
     &      err = 9901 )
C
      if( stat(1:1).eq.' ' .or. stat(1:1).eq.null ) then
        if( index(fin,':') .ne. 0 ) then
          stat = fin(index(fin,':')+1:)
        else
          stat = fin(index(fin,']')+1:)
        end if
      end if
c
    5 call tin( 'Give station ("XXXXXX" to stop) >', stat )
      call shiftup( stat )
      if( stat .eq. 'XXXXXX' ) return 1
C
      look = 1
    2 read( ind1, '(a6,a1)', end = 9902 ) statx, flag
      call shiftup( statx )
      if( iprint.ge.2 ) then
        write(*,*)'stat=',stat,'  statx read in=',statx
      endif
      if( stat .ne. statx ) goto 2
 
      if( fin .eq. '*' ) then
        goto 3
      end if
 
      call tin( STAT//' located; give type ("XXX" to stop) >', type )
      call shiftup( type )
      if( type .eq. 'XXX' ) return 1
 
    3 read( ind1, '(a3)', end = 9912 ) typex
      call shiftup( typex )
      if( type .ne. typex ) goto 3
 
      read( ind1, * ) nper
      if( iprint.ge.1 ) then
        write( out, '(a,a,a,i2)' ) ' Type ', type,
     &                           ' located with nper = ', nper
      endif
 
      if( flag .eq. '*' ) then
        do 7 i = 1, nper
          read( ind1, form, end=9904, err=9903 ) period(i),
     &    tfr(i), tfi(i), tferr(i), wtf(i)
          if(period(i).lt.0.)then
             period(i)= -1./period(i)
          endif
    7   continue
      else
        do 4 i = 1, nper
          read( ind1,    *, end=9904, err=9903 ) period(i),
     &    tfr(i), tfi(i), tferr(i), wtf(i)
          if(period(i).lt.0.)then
             period(i)= -1./period(i)
          endif
    4   continue
      end if
 
 
      if( iprint.ge.1 ) then
        write( out,* ) ' Successful completion for TFREAD'
      endif

      return
 
 9901 write( out, * ) ' TFREAD: error opening file -- correct name ?'
      goto 1
 
 9902 if( look.eq.1 ) then 
        write( out,* ) 'TFREAD: EOF looking for site ', stat, 
     &                 ' -- rewind made'
        rewind ind1
        look = 2
        goto 2
      else
        write( out,* ) 'TFREAD: EOF again, site not found in file'
        nper = -2
        return 1 
      endif
 
 9912 if( look.eq.1 ) then 
        write( out,* ) 'TFREAD: EOF looking for type ', type, 
     &                 ' in site ', site, '  -- rewind made'
        rewind ind1
        look = 2
        goto 2
      else
        write( out,* ) 'TFREAD: EOF again, type not found in file'
        nper = -2
        return 1 
      endif
  
 9903 write( out, * ) ' TFREAD: error during read, i = ', i
      return 1
 
 9904 write( out, * ) ' TFREAD: eof encountered during read, i = ', i
      return 1
 
 9905 write( out, * ) ' TFREAD: erroneous sequence of periods for ZAV',
     &                ' determination'
      return 1
 
      end
